<?php
/**
 * SphiderLite Version 2.6.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Admin
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)set.ee
 */
require "auth.php";
$backup_path="./backup/";

$table_names = array();
$query = "SELECT table_name FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE "
  ."= 'BASE TABLE' AND TABLE_SCHEMA='".$database."'";
$stmt = $db->prepare($query);
if ($stmt) {
    $stmt->execute() or die("Execution failed: ".$stmt->error);
    $stmt->bind_result($table_name);
    $stmt->store_result();
    $numtables = $stmt->num_rows;
    while ($stmt->fetch()) {
        array_push($table_names, $table_name);
    }
    $stmt->free_result();
    $stmt->close();
} else {
    trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
}

// Restore default settings
if ($send2=="RestoreSettings" && $Submit==$key) {
    $setquery = "SELECT * FROM ".$mysql_table_prefix."settings";
    $setstmt = $db->prepare($setquery);
    if ($setstmt) {
        $setstmt->execute() or die("Execution failed: ".$setstmt->error);
        $setstmt->store_result();
        $setrows = $setstmt->num_rows;
        $setstmt->free_result();
        $setstmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($setrows < 1) {
        $setinsertquery = "INSERT INTO ".$mysql_table_prefix."settings VALUES
            (1,'2.6.1','en','standard','admin@admin.com',1,'tmp',0,1,'log','html',
            0,10,5,100,1,0,'.',0,1,0,0,0,0,'/usr/bin/pdftotext',
            '/usr/bin/catdoc','/usr/bin/xls2csv','/usr/bin/catppt',
            '/usr/bin/pandoc','Sphider (sphidersearch.com)',0,0,120,30,0,'English',
            1,10,2,0,0,9,0,1,0,1,0,1,1,0,1,250,0,1,1,1,0,0,0,10,20, 60,10,5)";
        $setinsstmt = $db->prepare($setinsertquery);
        if ($setinsstmt) {
            $setinsstmt->execute() or die("Settings restoration failed!");
            $setinsstmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    } else {
        $setupdatequery = "UPDATE ".$mysql_table_prefix."settings SET
          version_nr  = '2.6.1',
          slanguage = 'en',
          template = 'standard',
          admin_email = 'admin@admin.com',
          print_results = 1,
          tmp_dir= 'tmp',
          windows_os = 0,
          keep_log = 1,
          log_dir = 'log',
          log_format = 'html',
          email_log = 0,
          min_words_per_page = 10,
          min_word_length = 5,
          word_upper_bound = 100,
          index_numbers = 1,
          index_decimals = 0,
          dec_separator = '.',
          index_host = 0,
          index_meta_keywords = 1,
          index_pdf = 0,
          index_doc = 0,
          index_xls = 0,
          index_ppt = 0,
          pdftotext_path = '/usr/bin/pdftotext',
          catdoc_path = '/usr/bin/catdoc',
          xls2csv_path = '/usr/bin/xls2csv',
          catppt_path = '/usr/bin/catppt',
          pandoc_path = '/usr/bin/pandoc',
          user_agent = 'Sphider (sphidersearch.com)',
          min_delay = 0,
          pause_ = 0,
          pause_time = 120,
          pause_pages = 30,
          stem_words = 0,
          stem_language = 'English',
          strip_sessids = 1,
          results_per_page = 10,
          cat_columns = 2,
          bound_search_result = 0,
          length_of_link_desc = 0,
          links_to_next = 9,
          qfloor = 0,
          show_meta_description = 1,
          advanced_search = 0,
          show_result_number = 1,
          show_index_date = 0,
          show_url = 0,
          show_query_scores = 1,
          show_stars = 0,
          show_categories = 1,
          desc_length = 250,
          merge_site_results = 0,
          did_you_mean_enabled = 1,
          suggest_enabled = 1,
          suggest_history = 1,
          suggest_keywords = 0,
          weighted_keywords = 0,
          suggest_phrases = 0,
          suggest_rows = 10,
          title_weight = 20,
          domain_weight= 60,
          path_weight = 10,
          meta_weight = 5
          WHERE id = 1";
        $setupdtstmt = $db->prepare($setupdatequery);
        if ($setupdtstmt) {
            $setupdtstmt->execute() or die("Settings restoration failed!");
            $setupdtstmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    }
    // Backup tables
} else {
    if ($Submit != $key) {
        exit;        
    }
    if (!is_dir($backup_path)) {
        mkdir($backup_path, 0766);
    }
    chmod($backup_path, 0777);
    $chkdtables = " ";
    if (!isset($_POST['chg'])) {
        foreach ($tables as $table) {
            $chkdtables .= $table." ";
        }
    }
    $flags = " --defaults-file=" . $settings_dir . "/my.cnf" . " --opt ";
    if (isset($structonly) && $structonly=="Yes") {
        $flags .= "--no-data ";
    }
    $backup_file = "./backup/" . $filename;
    $command = "mysqldump ".$flags.$dbname.$chkdtables." | gzip > $backup_file";
    exec($command);

}
