<?php
/**
 * SphiderLite Version 2.6.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Admin
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)set.ee
 */
session_start();
$include_dir = "../include";
require_once "$include_dir/commonfuncs.php";
require "auth.php";
if (!isset($_SESSION['keyset'])) {
    $_SESSION['keyset'] = md5(session_id().time().My_Mt_rand());
}
$key = $_SESSION['keyset'];
set_time_limit(0);
$all = 0;
extract(getHttpVars());
$settings_dir =  "../settings";
require_once "$settings_dir/conf.php";
$stem = stemInstance($stem_language);
require "messages.php";
require "spiderfuncs.php";
//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);

$delay_time = 0;

$command_line = 0;

ob_end_flush();

if (isset($_SERVER['argv']) && $_SERVER['argc'] >= 2) {
    $command_line = 1;
    $ac = 1; //argument counter
    while ($ac < (count($_SERVER['argv']))) {
        $arg = $_SERVER['argv'][$ac];
        $Submit = $key;
        if ($arg  == '-all') {
            $all = 1;
            break;
        } else if ($arg  == '-u') {
            $url = $_SERVER['argv'][$ac+1];
            $ac= $ac+2;
        } else if ($arg  == '-f') {
            $soption = 'full';
            $ac++;
        } else if ($arg == '-d') {
            $soption = 'level';
            $maxlevel =  $_SERVER['argv'][$ac+1];;
            $ac= $ac+2;
        } else if ($arg == '-s') {
            $usesitemap = 1;
            $ac++;
        } else if ($arg == '-l') {
            $domaincb = 1;
            $ac++;
        } else if ($arg == '-r') {
            $reindex = 1;
            $ac++;
        } else if ($arg == '-L') {
            $ctlang = $_SERVER['argv'][$ac+1];
            $ac= $ac+2;
        } else if ($arg  == '-m') {
            $in =  str_replace("\\n", chr(10), $_SERVER['argv'][$ac+1]);
            $ac= $ac+2;
        } else if ($arg  == '-n') {
            $out =  str_replace("\\n", chr(10), $_SERVER['argv'][$ac+1]);
            $ac= $ac+2;
        } else {
            commandLineHelp();
            die();
        }
    }
} /*elseif (isset($_SERVER['argv']) && $_SERVER['argc'] == 1) {
    commandLineHelp();
    die();
}*/

if (isset($soption) && $soption == 'full') {
    $maxlevel = -1;
}

if (!isset($usesitemap)) {
    $usesitemap = 0;
}

if (!isset($domaincb)) {
    $domaincb = 0;
}

if (!isset($reindex)) {
    $reindex = 0;
}

if (!isset($maxlevel) || $maxlevel == "") {
    $maxlevel = 2;
}

if (!isset($ctlang)) {
    $ctlang = "en";
}

if ($keep_log) {
    if ($log_format == "html") {
        $log_file =  $log_dir."/".Date("ymdHi").".html";
    } else {
        $log_file =  $log_dir."/".Date("ymdHi").".log";
    }

    if (!$log_handle = fopen($log_file, 'w')) {
        die("Logging option is set, but cannot open file for logging.");
    }
}

if ($all ==  1) {
    indexAll();
} else {
    if ($reindex == 1 && $command_line == 1) {
        $stmt = $db->prepare(
            "SELECT url, spider_depth, required, disallowed, "
            ."usesitemap, can_leave_domain, ct_lang FROM "
            .$mysql_table_prefix."sites WHERE url = ? "
        );
        if ($stmt) {
            $stmt->bind_param("s", $url);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row=$result->fetch_array(MYSQLI_NUM)) {
            $url = $row[0];
            $maxlevel = $row[1];
            $in= $row[2];
            $out = $row[3];
            $usesitmap = $row[4];
            if ($usesitemap=='') {
                $usesitemap=0;
            }
            $domaincb = $row[5];
            if ($domaincb=='') {
                $domaincb=0;
            }
            if ($maxlevel == -1) {
                $soption = 'full';
            } else {
                $soption = 'level';
            }
            $ctlang = $row[6];
        }

    }
    if (!isset($in)) {
        $in = "";
    }
    if (!isset($out)) {
        $out = "";
    }

    indexSite(
        $url, $reindex, $maxlevel, $soption, $in, $out, $usesitemap,
        $domaincb, $ctlang
    );

}

$tmp_urls  = Array();


/**
 * Function to index a specific url
 *
 * @param string $url              The url to be indexed
 * @param int    $level            How deep the indexing should proceed
 * @param int    $site_id          The id of the site being indexed
 * @param string $md5sum           Hash of the page contents to determine
 *                                 if any change since last indexed
 * @param int    $domain           The domain being indexed
 * @param date   $indexdate        Date the url is being indexed
 * @param string $sessid           The indexing session id
 * @param int    $usesitemap       Flag indicating if the sitemap.xml should
 *                                 be followed provided it exists
 * @param int    $can_leave_domain Flag indicating if url's from other domains
 *                                 should be indexed
 * @param string $ctlang           Common text language
 * @param int    $reindex          Flag indicating if this url is being re-indexed
 *
 * @return void
 */
function indexUrl($url, $level, $site_id, $md5sum, $domain, $indexdate,
    $sessid, $usesitemap, $can_leave_domain, $ctlang, $reindex
) {

    global $entities, $min_delay, $command_line, $min_words_per_page, $db;
    global $supdomain, $usesitemap, $valmap, $omit, $charset, $ctlang;
    global $mysql_table_prefix, $user_agent, $tmp_urls, $delay_time, $domain_arr;
    global $pglang, $com_txt_langs, $pause_, $pause_time, $pause_pages;

    static $indexctr;
    
    if (!isset($indexctr)) {
        $indexctr = 0;
    }

    $needsReindex = 1;
    $deletable = 0;

    $charset = readHeaders($url);

    $url_status = urlStatus($url);
    $thislevel = $level - 1;
    if ($data['nofollow'] != 1) {
        if ($usesitemap == 1 && !isset($valmap)) {
            printStandardReport('useSiteMap', $command_line);
            $urlparts = parse_url($url);
            $mapurl = $urlparts['scheme']."://".$urlparts['host']."/sitemap.xml";
            if (!$links = getSiteMap($mapurl)) {
                // If we can't get a valid sitemap, turn off the usesitemap option
                $stmt = $db->prepare(
                    "UPDATE ".$mysql_table_prefix."sites "
                    ."SET usesitemap = 0 WHERE site_id = ?"
                );
                if ($stmt) {
                    $stmt->bind_param("i", $site_id);
                    $stmt->execute() or die("Execution failed: ".$stmt->error);
                    $stmt->close();
                } else {
                    trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
                }
                $usesitemap = 0;
                printStandardReport('SiteMapUnavail', $command_line);
            } else {
                if ($links != '') {
                    reset($links);
                    foreach ($links as $key => $thislink) {
                        $stmt = $db->prepare(
                            "INSERT INTO ".$mysql_table_prefix
                            ."temp (link, level, id) VALUES ( ? , ? , ? )"
                        );
                        if ($stmt) {
                            $stmt->bind_param("sis", $thislink, $level, $sessid);
                            $stmt->execute() 
                              or die("Execution failed: ".$stmt->error);
                            $stmt->close();
                        } else {
                            trigger_error(
                                'Statement failed : '
                                .$db->error, E_USER_ERROR
                            );
                        }
                    }
                    $valmap = 1;
                } else {
                    // If the links array was empty, the sitemap was invalid
                    $stmt = $db->prepare(
                        "UPDATE ".$mysql_table_prefix."sites "
                        ."SET usesitemap = 0 WHERE site_id = ?"
                    );
                    if ($stmt) {
                        $stmt->bind_param("i", $site_id);
                        $stmt->execute() or die("Execution failed: ".$stmt->error);
                        $stmt->close();
                    } else {
                        trigger_error(
                            'Statement failed : '
                            .$db->error, E_USER_ERROR
                        );
                    }
                    $usesitemap = 0;
                    printStandardReport('SiteMapUnavail', $command_line);
                }
            }
        }
    } else {
        printStandardReport('noFollow', $command_line);
    }

    if (strstr($url_status['state'], "Relocation")) {
        $url = preg_replace(
            "/ /", "", urlPurify(
                $url_status['path'],
                $url, $can_leave_domain
            )
        );

        if ($url <> '') {
            $stmt = $db->prepare(
                "SELECT link FROM ".$mysql_table_prefix
                ."temp WHERE link = ? AND id = ? "
            );
            if ($stmt) {
                $stmt->bind_param("ss", $url, $sessid);
                $stmt->execute() or die("Execution failed: ".$stmt->error);
                $result = $stmt->get_result();
                $stmt->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
            $rows = $result->num_rows;
            if ($rows == 0) {
                $stmt = $db->prepare(
                    "INSERT INTO ".$mysql_table_prefix
                    ."temp (link, level, id) VALUES ( ? , ? , ? )"
                );
                if ($stmt) {
                    $stmt->bind_param("sis", $url, $level, $sessid);
                    $stmt->execute() or die("Execution failed: ".$stmt->error);
                    $stmt->close();
                } else {
                    trigger_error(
                        'Statement failed : '
                        .$db->error, E_USER_ERROR
                    );
                }
            }
        }
        // The last two lines are a HACK for bypassing 301 errors!
        // Uncomment (remove //) ONLY if absolutely necessary!
        // $url_status['state'] = "ok";
        // $url_status['content'] = "text";
    }

    ini_set("user_agent", $user_agent);
    if ($url_status['state'] == 'ok') {
        $OKtoIndex = 1;
        $file_read_error = 0;
        if ($pause_ == 1) {
            if ($indexctr == $pause_pages) {
                $indexctr = 0;
                sleep($pause_time);
            }
        }
        if (time() - $delay_time < $min_delay) {
            sleep($min_delay - (time() - $delay_time));
        }
        $delay_time = time();
        $file = @file_get_contents($url);
        if ($file === false) {
            $file_read_error = 1;
        }

        if ($file_read_error) {
            $contents = getFileContents($url);
            $file = $contents['file'];
        }

        $pageSize = number_format(mb_strlen($file, 'utf-8')/1024, 2, ".", "");
        printPageSizeReport($pageSize);
// Special (and rare) case of header mislabeling "pdf" file as "text"
if ($url_status['content'] == "text" && strcmp(mb_substr($file, 0, 5), "%PDF-") == 0) {
    $url_status['content'] = "pdf";
}
        if ($url_status['content'] != 'text') {
            if ($url_status['content'] == "pdf") {
                $charset = "UTF-8";
            }            
            if ($url_status['content'] == "doc") {
                $charset = "ASCII";
            }            
            $stmt = $db->prepare(
                "SELECT windows_os FROM "
                .$mysql_table_prefix."settings WHERE id = '1'"
            );
            if ($stmt) {
                $stmt->execute() or die("Execution failed: ".$stmt->error);
                $stmt->bind_result($windows_os);
                $stmt->fetch();
                $stmt->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
            if ($windows_os == 1) {
                $file = winExtractText($file, $url_status['content']);
            } else {
                $file = extractText($file, $url_status['content']);
            }
        }

        printStandardReport('starting', $command_line);

        $newmd5sum = md5($file);

        getPageLanguage($file);

        if ($md5sum == $newmd5sum) {
            printStandardReport('md5notChanged', $command_line);
            $OKtoIndex = 0;
        } else if (isDuplicateMD5($newmd5sum)) {
            $OKtoIndex = 0;
            printStandardReport('duplicate', $command_line);
        }

        if (($md5sum != $newmd5sum || $reindex ==1) && $OKtoIndex == 1) {
            $urlparts = parse_url($url);
            $newdomain = $urlparts['host'];
            $type = 0;
            $data = cleanFile($file, $url, $url_status['content'], $charset);

            if ($data['noindex'] == 1) {
                $OKtoIndex = 0;
                $deletable = 1;
                printStandardReport('metaNoindex', $command_line);
            }

            $wordarray = uniqueArray(explode(" ", $data['content']));

            if (!isset($valmap)) {
                if ($data['nofollow'] != 1) {
                    $links = getLinks(
                        $file, $url, $can_leave_domain, $data['base']
                    );
                    $links = distinctArray($links);
                    $all_links = count($links);
                    $numoflinks = 0;
                    //if there are any, add to the temp table,
                    //but only if there isnt such url already
                    if (is_array($links)) {
                        reset($links);
                        foreach ($links as $key => $thislink) {
                            if ($tmp_urls[$thislink] != 1) {
                                $tmp_urls[$thislink] = 1;
                                $numoflinks++;
                                $stmt =$db->prepare(
                                    "INSERT INTO "
                                    .$mysql_table_prefix."temp (link, level, id) "
                                    ."VALUES ( ? , ? , ? )"
                                );
                                if ($stmt) {
                                    $stmt->bind_param(
                                        "sis", substr($thislink, 0, 255),
                                        $level, $sessid
                                    );
                                    $stmt->execute() 
                                      or die("Execution failed: ".$stmt->error);
                                    $stmt->close();
                                } else {
                                    trigger_error(
                                        'Statement failed : '
                                        .$db->error, E_USER_ERROR
                                    );
                                }
                            }
                        }
                    }

                } else {
                    printStandardReport('noFollow', $command_line);
                }
            }

            if ($OKtoIndex == 1) {
                $title = mb_substr($data['title'] ?? '', 0, 199, 'utf-8');
                if (is_null($title)) { 
                    $title = "";
                }
                $desc = mb_substr($data['description'] ?? '', 0, 254, 'utf-8');
                if (is_null($desc)) { 
                    $desc = "";
                }
                foreach ($entities as $key => $char) {
                    $title = preg_replace("/".$key."/i", $char, $title);
                    $desc = preg_replace("/".$key."/i", $char, $desc);
                }
                $host = $data['host'];
                $path = $data['path'];
                $fulltxt = $data['fulltext'];
                $url_parts = parse_url($url);
                $domain_for_db = $url_parts['host'];

                if (isset($domain_arr[$domain_for_db])) {
                     $dom_id = $domain_arr[$domain_for_db];
                } else {
                    $stmt = $db->prepare(
                        "INSERT INTO ".$mysql_table_prefix
                        ."domains (domain) VALUES ( ? )"
                    );
                    if ($stmt) {
                        $stmt->bind_param("s", $domain_for_db);
                        $stmt->execute() or die("Execution failed: ".$stmt->error);
                        $dom_id = $stmt->insert_id;
                        $stmt->close();
                    } else {
                        trigger_error(
                            'Statement failed : '
                            .$db->error, E_USER_ERROR
                        );
                    }
                    $domain_arr[$domain_for_db] = $dom_id;
                }

                $wordarray = calcWeights(
                    $wordarray, $title, $host, $path,
                    $data['keywords']
                );

                // if there are words to index, add the link to the database,
                // get its id, and add the word + their relation
                if (is_array($wordarray) && count($wordarray) >$min_words_per_page
                ) {
                    if ($md5sum == '') {
                        $stmt = $db->prepare(
                            "INSERT INTO ".$mysql_table_prefix
                            ."links (site_id, url, title, description, fulltxt, "
                            ."indexdate, size, md5sum, level) VALUES ( ? , ? , ? ,"
                            ." ? , ? , CURDATE(), ? , ? , ? )"
                        );
                        if ($stmt) {
                            $stmt->bind_param(
                                "issssdsi", $site_id, $url, $title,
                                $desc, $fulltxt, $pageSize, $newmd5sum, $thislevel
                            );
                            $stmt->execute() 
                              or die("Execution failed: ".$stmt->error);
                            $stmt->close();
                        } else {
                            trigger_error(
                                'Statement failed : '
                                .$db->error, E_USER_ERROR
                            );
                        }
                        $stmt = $db->prepare(
                            "SELECT link_id FROM "
                            .$mysql_table_prefix."links WHERE url = ? "
                        );
                        if ($stmt) {
                            $stmt->bind_param("s", $url);
                            $stmt->execute()
                              or die("Execution failed: ".$stmt->error);
                            $result = $stmt->get_result();
                            $stmt->close();
                        } else {
                            trigger_error(
                                'Statement failed : '.$db->error, E_USER_ERROR
                            );
                        }
                        $row = $result->fetch_array(MYSQLI_NUM);
                        $link_id = $row[0];
                        saveKeywords($wordarray, $link_id, $dom_id);
                        printStandardReport('indexed', $command_line);
                        if ($pause_ == 1) {
                            ++$indexctr;
                        }
                    } else if (($md5sum <> '') && ($md5sum <> $newmd5sum)) {
                        //if page has changed, start updating
                        $stmt = $db->prepare(
                            "SELECT link_id FROM "
                            .$mysql_table_prefix."links WHERE url = ? "
                        );
                        if ($stmt) {
                            $stmt->bind_param("s", $url);
                            $stmt->execute()
                              or die("Execution failed: ".$stmt->error);
                            $result = $stmt->get_result();
                            $stmt->close();
                        } else {
                            trigger_error(
                                'Statement failed : '.$db->error, E_USER_ERROR
                            );
                        }
                        $row = $result->fetch_array(MYSQLI_NUM);
                        $link_id = $row[0];
                        for ($i=0;$i<=15; $i++) {
                            $char = dechex($i);
                            $stmt = $db->prepare(
                                "DELETE FROM "
                                .$mysql_table_prefix."link_keyword"
                                .$char." WHERE link_id = ? "
                            );
                            if ($stmt) {
                                $stmt->bind_param("i", $link_id);
                                $stmt->execute()
                                  or die("Execution failed: ".$stmt->error);
                                $stmt->close();
                            } else {
                                trigger_error(
                                    'Statement failed : '
                                    .$db->error, E_USER_ERROR
                                );
                            }
                        }
                        saveKeywords($wordarray, $link_id, $dom_id);
                        $stmt = $db->prepare(
                            "UPDATE ".$mysql_table_prefix
                            ."links SET title = ? , description = ? , fulltxt = ?"
                            ." , indexdate = NOW(), size = ? , md5sum = ? , "
                            ."level = ? WHERE link_id = ? "
                        );
                        if ($stmt) {
                            $stmt->bind_param(
                                "sssdsii", $title, $desc, $fulltxt,
                                $pageSize, $newmd5sum, $thislevel, $link_id
                            );
                            $stmt->execute() 
                              or die("Execution failed: ".$stmt->error);
                            $stmt->close();
                        } else {
                            trigger_error(
                                'Statement failed : '.$db->error, E_USER_ERROR
                            );
                        }
                        printStandardReport('re-indexed', $command_line);
                        if ($pause_ == 1) {
                            ++$indexctr;
                        }
                    }
                } else {
                    printStandardReport('minWords', $command_line);
                }
            }
        }
    } else {
        $deletable = 1;
        printUrlStatus($url_status['state'], $command_line);
    }
    if ($reindex ==1 && $deletable == 1) {
        checkForRemoval($url);
    } // else if ($reindex == 1) {

    if (!isset($all_links)) {
        $all_links = 0;
    }
    if (!isset($numoflinks)) {
        $numoflinks = 0;
    }
    printLinksReport($numoflinks, $all_links, $command_line);
}


/**
 * Function which parses a site to find pages to index
 *
 * @param string $url              The url of the site being indexed
 * @param int    $reindex          Flag indicating if this is a re-index
 * @param int    $maxlevel         Indicates how many levels into the
 *                                 site to index
 * @param int    $soption          Flag indicating to do a full index
 *                                 (unlimited levels)
 * @param string $url_inc          List of MUST include items
 * @param string $url_not_inc      List of items that must NOT be included
 * @param int    $usesitemap       Flag to use a sitemap if available
 * @param int    $can_leave_domain Flag indicating whether or not sphider should
 *                                 index pages not in the site's domain
 * @param string $ctlang           Common text language
 * 
 * @return void
 */
function indexSite($url, $reindex, $maxlevel, $soption, $url_inc, $url_not_inc,
    $usesitemap, $can_leave_domain, $ctlang
) {

    global $mysql_table_prefix, $command_line, $mainurl, $tmp_urls, $domain_arr;
    global $valmap, $omit, $all_keywords, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    if (!isset($all_keywords)) {
        $stmt = $db->prepare(
            "SELECT keyword_id, keyword FROM "
            .$mysql_table_prefix."keywords"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        while ($row=$result->fetch_array(MYSQLI_ASSOC)) {
            $all_keywords[$row['keyword']] = $row['keyword_id'];
        }
    }
    $compurl = parse_url($url);
    if ($compurl['path'] == '') {
        $url = $url . "/";
    }

    $t = microtime();
    $a =  getenv("REMOTE_ADDR");
    $sessid = md5($t.$a);

    $urlparts = parse_url($url);

    $domain = $urlparts['host'];
    if (isset($urlparts['port'])) {
        $port = (int)$urlparts['port'];
    } else {
        $port = 80;
    }

    $stmt = $db->prepare(
        "SELECT site_id FROM ".$mysql_table_prefix
        ."sites WHERE url = ? "
    );
    if ($stmt) {
        $stmt->bind_param("s", $url);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $site_id = $row[0];

    if ($site_id != "" && $reindex == 1) {
        $stmt = $db->prepare(
            "INSERT INTO ".$mysql_table_prefix
            ."temp (link, level, id) VALUES ( ?, 0, ? )"
        );
        if ($stmt) {
            $stmt->bind_param("ss", $url, $sessid);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $stmt = $db->prepare(
            "SELECT url, level FROM ".$mysql_table_prefix
            ."links WHERE site_id = ? "
        );
        if ($stmt) {
            $stmt->bind_param("i", $site_id);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
            $site_link = $row['url'];
            $link_level = $row['level'];
            if ($site_link != $url) {
                $istmt = $db->prepare(
                    "INSERT INTO ".$mysql_table_prefix
                    ."temp (link, level, id) VALUES ( ? , ? , ? )"
                );
                if ($istmt) {
                    $istmt->bind_param("sis", $site_link, $link_level, $sessid);
                    $istmt->execute() or die("Execution failed: ".$istmt->error);
                    $istmt->close();
                } else {
                    trigger_error(
                        'Statement failed : '.$db->error, E_USER_ERROR
                    );
                }
            }
        }

        $ustmt = $db->prepare(
            "UPDATE ".$mysql_table_prefix."sites "
            ."SET indexdate = NOW(), spider_depth = ? , required = ? , disallowed "
            ."= ? , usesitemap = ? , can_leave_domain = ?, ct_lang = ? "
            ."WHERE site_id = ? "
        );
        if ($ustmt) {
            $ustmt->bind_param(
                "issiisi", $maxlevel, $url_inc, $url_not_inc,
                $usesitemap, $can_leave_domain, $ctlang, $site_id
            );
            $ustmt->execute() or die("Execution failed: ".$ustmt->error);
            $ustmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    } else if ($site_id == '') {
        $stmt = $db->prepare(
            "INSERT INTO ".$mysql_table_prefix."sites (url, "
            ."indexdate, spider_depth, required, disallowed, usesitemap, "
            ."can_leave_domain, ct_lang) VALUES ( ? , NOW(), ? , ? , ? , "
            ."? , ? , ?)"
        );
        if ($stmt) {
            $stmt->bind_param(
                "sissiis", $url, $maxlevel, $url_inc, $url_not_inc,
                $usesitemap, $can_leave_domain, $ctlang
            );
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $stmt = $db->prepare(
            "SELECT site_ID FROM ".$mysql_table_prefix
            ."sites WHERE url = ? "
        );
        if ($stmt) {
            $stmt->bind_param("s", $url);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $row = $result->fetch_array(MYSQLI_NUM);
        $site_id = $row[0];
    } else {
        $stmt = $db->prepare(
            "UPDATE ".$mysql_table_prefix."sites SET indexdate"
            ." = NOW(), spider_depth = ? , required = ? , disallowed = ? , "
            ."usesitemap = ? , can_leave_domain = ? , ct_lang = ? WHERE site_id = ? "
        );
        if ($stmt) {
            $stmt->bind_param(
                "issiisi", $maxlevel, $url_inc, $url_not_inc,
                $usesitemap, $can_leave_domain, $ctlang, $site_id
            );
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    }

    $stmt = $db->prepare(
        "SELECT site_id, temp_id, level, count, num from "
        .$mysql_table_prefix."pending WHERE site_id = ? "
    );
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $pending = $row[0];
    $level = 0;
    $domain_arr = getDomains();
    if ($pending == '') {
        $stmt = $db->prepare(
            "INSERT INTO ".$mysql_table_prefix
            ."temp (link, level, id) VALUES ( ? , 0, ? )"
        );
        if ($stmt) {
            $stmt->bind_param("ss", $url, $sessid);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    } else if ($pending != '') {
        printStandardReport('continueSuspended', $command_line);
        $sessid = $row[1];
        $level = $row[2];
        $pend_count = $row[3] + 1;
        $num = $row[4];
        $pending = 1;
        $tmp_urls = getTempUrls($sessid);
    }

    if ($reindex != 1) {
        $stmt = $db->prepare(
            "INSERT INTO ".$mysql_table_prefix
            ."pending (site_id, temp_id, level, count) VALUES ( ? , ? , '0', '0')"
        );
        if ($stmt) {
            $stmt->bind_param("is", $site_id, $sessid);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    }

    $time = time();

    $omit = checkRobotTxt($url);
    printHeader($omit, $url, $command_line, 0);

    $mainurl = $url;
    $num = 0;

    while (($level <= $maxlevel && $soption == 'level') || ($soption == 'full')) {
        if ($pending == 1) {
            $count = $pend_count;
            $pending = 0;
        } else {
            $count = 0;
        }

        $links = array();

        $stmt = $db->prepare(
            "SELECT DISTINCT link FROM ".$mysql_table_prefix
            ."temp WHERE level = ? AND id = ? ORDER BY link"
        );
        if ($stmt) {
            $stmt->bind_param("is", $level, $sessid);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }

        $rows = $result->num_rows;
        if ($rows == 0) {
            break;
        }

        $i = 0;

        while ($row = $result->fetch_assoc()) {
            $links[] = $row['link'];
        }

        reset($links);

        while ($count < count($links)) {
            $num++;
            $thislink = $links[$count];
            $urlparts = parse_url($thislink);
            if (is_array($omit['allow'])) {
                reset($omit['allow']);
            }
            if (is_array($omit['deny'])) {
                reset($omit['deny']);
            }
            $forbidden = 0;
            if (is_array($omit['deny'])) {
                foreach ($omit['deny'] as $omiturl) {
                    $omiturl = trim($omiturl);
                    $omiturl_parts = parse_url($omiturl);
                    if ($omiturl_parts['scheme'] == '') {
                        $check_omit = $urlparts['host'] . $omiturl;
                    } else {
                        $check_omit = $omiturl;
                    }
                    // Check for the non-standard use of wildcard (*) in robots.txt
                    if (strpos($check_omit, "*")) {
                        $omitparts = explode("*", $check_omit);
                        if (mb_strpos($thislink, $omitparts[0], 0, 'utf-8')
                            && mb_strpos($thislink, $omitparts[1], 0, 'utf-8')
                        ) {
                            if (checkAllow($thislink, $check_omit, $omit['allow'])) {
                                break;
                            } else {
                                printRobotsReport($num, $thislink, $command_line);
                                checkForRemoval($thislink);
                                $forbidden = 1;
                                break;
                            }
                        }

                    }
                    // Return to standard robots.txt checking
                    if (mb_strpos($thislink, $check_omit, 0, 'utf-8')) {
                        if (checkAllow($thislink, $check_omit, $omit['allow'])) {
                            break;
                        } else {
                            printRobotsReport($num, $thislink, $command_line);
                            checkForRemoval($thislink);
                            $forbidden = 1;
                            break;
                        }
                    }
                }
            }

            if (!checkInclude($thislink, $url_inc, $url_not_inc)) {
                printUrlStringReport($num, $thislink, $command_line);
                checkForRemoval($thislink);
                $forbidden = 1;
            }

            if ($forbidden == 0) {
                printRetrieving($num, $thislink, $command_line);
                $stmt = $db->prepare(
                    "SELECT md5sum, indexdate FROM "
                    .$mysql_table_prefix."links WHERE url = ? "
                );
                if ($stmt) {
                    $stmt->bind_param("s", $thislink);
                    $stmt->execute() or die("Execution failed: ".$stmt->error);
                    $result = $stmt->get_result();
                    $stmt->close();
                } else {
                    trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
                }
                $rows = $result->num_rows;
                if ($rows == 0) {
                    indexUrl(
                        $thislink, $level+1, $site_id, '',  $domain, '',
                        $sessid, $usesitemap, $can_leave_domain, $ctlang, $reindex
                    );
                    $stmt = $db->prepare(
                        "UPDATE ".$mysql_table_prefix
                        ."pending SET level = ? , count = ? , num = ? WHERE "
                        ."site_id = ? "
                    );
                    if ($stmt) {
                        $stmt->bind_param("iiii", $level, $count, $num, $site_id);
                        $stmt->execute() or die("Execution failed: ".$stmt->error);
                        $stmt->close();
                    } else {
                        trigger_error(
                            'Statement failed : '
                            .$db->error, E_USER_ERROR
                        );
                    }
                } else if ($rows <> 0 && $reindex == 1) {
                    $row = $result->fetch_array(MYSQLI_ASSOC);
                    $md5sum = $row['md5sum'];
                    $indexdate = $row['indexdate'];
                    indexUrl(
                        $thislink, $level+1, $site_id, $md5sum,  $domain,
                        $indexdate, $sessid, $usesitemap, $can_leave_domain,
                        $ctlang, $reindex
                    );
                    $stmt = $db->prepare(
                        "UPDATE ".$mysql_table_prefix
                        ."pending SET level = ? , count = ? , num = ? "
                        ."WHERE site_id = ? "
                    );
                    if ($stmt) {
                        $stmt->bind_param("iiii", $level, $count, $num, $site_id);
                        $stmt->execute() or die("Execution failed: ".$stmt->error);
                        $stmt->close();
                    } else {
                        trigger_error(
                            'Statement failed : '
                            .$db->error, E_USER_ERROR
                        );
                    }
                } else {
                    printStandardReport('inDatabase', $command_line);
                }
            }
            $count++;
        }
        $level++;
    }

    $stmt = $db->prepare(
        "DELETE FROM ".$mysql_table_prefix
        ."temp WHERE id = ? "
    );
    if ($stmt) {
        $stmt->bind_param("s", $sessid);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $stmt = $db->prepare(
        "DELETE FROM "
        .$mysql_table_prefix."pending WHERE site_id = ? "
    );
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    printStandardReport('completed', $command_line);
    unset($valmap);

}


/**
 * Function to initiate indexing of ALL sites
 *
 * @return void
 */
function indexAll()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $stmt = $db->prepare(
        "SELECT url, spider_depth, required, disallowed, "
        ."usesitemap, can_leave_domain FROM "
          .$mysql_table_prefix."sites"
    );
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    while ($row=$result->fetch_array(MYSQLI_NUM)) {
        $url = $row[0];
        $depth = $row[1];
        $include = $row[2];
        $not_include = $row[3];
        $usesitemap = $row[4];
        if ($sitemap=='') {
            $usesitemap=0;
        }
        $can_leave_domain = $row[5];
        if ($can_leave_domain=='') {
            $can_leave_domain=0;
        }
        if ($depth == -1) {
            $soption = 'full';
        } else {
            $soption = 'level';
        }
        indexSite(
            $url, 1, $depth, $soption, $include, $not_include, $usesitemap,
            $can_leave_domain, $ctlang
        );
    }
}


/**
 * Function to return list of url's stored during suspended indexing
 *
 * @param string $sessid The id of the suspended session
 *
 * @return array An array of stored url's
 */
function getTempUrls($sessid)
{
    global $mysql_table_prefix, $db;

    $stmt = $db->prepare(
        "SELECT link FROM "
        .$mysql_table_prefix."temp WHERE id = ? "
    );
    if ($stmt) {
        $stmt->bind_param("s", $sessid);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $tmp_urls = Array();
    while ($row=$result->fetch_array(MYSQLI_NUM)) {
        $tmp_urls[$row[0]] = 1;
    }
    return $tmp_urls;

}


/**
 * Function to return a list of all domains in the DB
 *
 * @return array An array of all domains in the DB
 */
function getDomains()
{
    global $mysql_table_prefix, $db;

    $stmt = $db->prepare(
        "SELECT domain_id, domain FROM "
        .$mysql_table_prefix."domains"
    );
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $domains = Array();
    while ($row=$result->fetch_array(MYSQLI_NUM)) {
        $domains[$row[1]] = $row[0];
    }
    return $domains;

}


/**
 * Command Line Help
 *
 * @return void
 */
function commandLineHelp()
{
    print "Usage: php spider.php <options>\n\n";
    print "Options:\n";
    print " -all\t\t Reindex everything in the database\n";
    print " -u <url>\t Set url to index\n";
    print " -f\t\t Set indexing depth to full (unlimited depth)\n";
    print " -d <num>\t Set indexing depth to <num>\n";
    print " -s\t\t Use sitemap if available\n";
    print " -l\t\t Allow spider to leave the initial domain\n";
    print " -r\t\t Set spider to reindex a site\n";
    print " -L <lang>\t Common text language\n";
    print " -m <string>\t Set the string(s) that an url must include "
      ."(use \\\\n\n\t\t as a delimiter between multiple strings)\n";
    print " -n <string>\t Set the string(s) that an url must not include "
      ."(use \\\\n\n\t\t as a delimiter between multiple strings)\n";
}

printStandardReport('quit', $command_line);

if ($email_log) {
    $indexed = ($all==1) ? 'ALL' : $url;
    $log_report = "";
    if ($log_handle) {
        $log_report = "Log saved into ".$log_file;
    }
    mail(
        $admin_email, "Sphider indexing report", "Sphider has finished indexing "
        .$indexed." at ".date('y-m-d H:i:s').". ".$log_report
    );
}

if ($log_handle) {
    fclose($log_handle);
}
