<?php
/**
 * SphiderLITE Version 2.6.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Installation
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<html>";
echo "<head>";
echo "<title>";
echo "Update version number to 2.6.1.";
echo "</title>";
echo "<LINK REL=STYLESHEET HREF='admin.css' TYPE='text/css'>";
echo "</head>";
echo "<body>";
echo "<h2>Update the database version number.</h2>";

//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);
$settings_dir = "../settings";
require "$settings_dir/database.php";

$error = 0;
$state = 0;
$ver_list = array(
    "1.0.0", "1.1.0", "1.1.1", "1.1.2", "1.1.3", "1.1.4", "1.1.5", "1.2.0", "1.2.1", "1.2.2", "1.2.3", "1.3.0", "1.3.1",
    "1.3.2", "2.0.0", "2.0.1", "2.0.2", "2.1.0", "2.2.0", "2.2.1", "2.3.0", "2.3.1", "2.4.0", "2.5.0", "2.6.0", "2.6.1"
);
$ver_count = count($ver_list);

$result = $db->query("SHOW TABLES LIKE '%settings'");
if ($result->num_rows < 1) {
    $state = 1;    // There is no settings table, unrecognized version
} else {
    $result = $db->query(
        "SELECT version_nr FROM ".$mysql_table_prefix
        ."settings WHERE id = 1"
    );
    $row = $result->fetch_row();
    for ($i = 0; $i < $ver_count; $i++) {
        if (strcmp($ver_list[$i], $row[0]) === 0) {
            $state = 2;    // We have found the version number
            break;
        }
    }
}

if (!$state == 2) {    // There is no settings table, or unrecognized version
    echo "Version unrecognized or not supported.<br>";
    echo "New install recommended.";
    echo "</body>";
    echo "</html>";
    exit;
}

switch ($i) {
case 0:
case 1:
case 2:
case 3:
case 4:
case 5:
case 6:
case 7:
case 8:
case 9:
case 10:
case 11:
case 12:
case 13:
case 14:
case 15:
case 16:
    echo "SphiderLite version is outdated><br>New install is recommended.";
    echo "</body>";
    echo "</html>";
    exit;
case 17:
    update220();
case 18:
    update221();
case 19:
    update230();
case 20:
    update231();
case 21:
    update240();
case 22:
    update250();
case 23:
    update260();
case 24:
    update261();
    break;
default:
    echo "You already have the latest version installed.<br>"
         ."Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
    echo "</body>";
    echo "</html>";
    exit;
}

if ($error >0) {
    print "<b>Updating the database failed. Consult the above error messages.</b>";
    echo "</body>";
    echo "</html>";
    exit;
} else {
    echo "<b>You have successfully updated the database to version ".$ver
    .". Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
}

echo "</body>";
echo "</html>";

/***********************************************************************************************/
/*                                          FUNCTIONS                                          */
/***********************************************************************************************/

/**
 * Update to version 2.2.0
 *
 * @return void
 */
function update220()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Modify description in links table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix."links
        MODIFY COLUMN description text"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.2.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.2.0";
}

/**
 * Update to version 2.2.1
 *
 * @return void
 */
function update221()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.2.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.2.1";
}

/**
 * Update to version 2.3.0
 *
 * @return void
 */
function update230()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.3.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.3.0";
}

/**
 * Update to version 2.3.1
 *
 * @return void
 */
function update231()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.3.1',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.3.1";
}

/**
 * Update to version 2.4.0
 *
 * @return void
 */
function update240()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.4.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.4.0";
}

/**
 * Update to version 2.5.0
 *
 * @return void
 */
function update250()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Create new column pandoc_path in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pandoc_path VARCHAR(45) NULL DEFAULT NULL
        AFTER catppt_path"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_ in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_ INT NULL DEFAULT NULL
        AFTER min_delay"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_time INT NULL DEFAULT NULL
        AFTER pause_"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_pages in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_pages INT NULL DEFAULT NULL
        AFTER pause_time"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column cft_lang in sites table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."sites ADD COLUMN ct_lang VARCHAR(10) NOT NULL DEFAULT 'en'
        AFTER can_leave_domain"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.5.0',
        pandoc_path='/usr/bin/pandoc',
        pause_='0',
        pause_time='120',
        pause_pages='30'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.5.0";
}

/**
 * Update to version 2.6.0
 *
 * @return void
 */
function update260()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Change column 'language' to 'slanguage'
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings CHANGE COLUMN language slanguage VARCHAR(5) NULL DEFAULT NULL"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    
    // Create new column dec_separator in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN dec_separator VARCHAR(2) NULL DEFAULT NULL
        AFTER index_decimals"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    // Restore defaults on possible corrupted settings
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.6.0',
        dec_separator='.',
        cat_columns='2',
        bound_search_result='0',
        length_of_link_desc='0',
        links_to_next='9'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.6.0";
}

/**
 * Update to version 2.6.1
 *
 * @return void
 */
function update261()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.6.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.6.1";
}
