CREATE TABLE sites (
  site_id int(11) NOT NULL AUTO_INCREMENT,
  url varchar(255) DEFAULT NULL,
  title varchar(255) DEFAULT NULL,
  short_desc text,
  indexdate date DEFAULT NULL,
  spider_depth int(11) DEFAULT '2',
  required text,
  disallowed text,
  usesitemap tinyint(1) DEFAULT '0',
  can_leave_domain tinyint(1) DEFAULT '0',
  ct_lang varchar(10) NOT NULL DEFAULT 'en',
  PRIMARY KEY (site_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE links (
  link_id int(11) NOT NULL AUTO_INCREMENT,
  site_id int(11) DEFAULT NULL,
  url varchar(255) NOT NULL,
  title varchar(200) DEFAULT NULL,
  description text DEFAULT NULL,
  fulltxt longtext,
  indexdate date DEFAULT NULL,
  size float DEFAULT NULL,
  md5sum varchar(32) DEFAULT NULL,
  visible int(11) DEFAULT '0',
  level int(11) DEFAULT NULL,
  PRIMARY KEY (link_id),
  KEY url (url),
  KEY md5key (md5sum),
  KEY site_id (site_id),
  CONSTRAINT links_ibfk_1 FOREIGN KEY (site_id) REFERENCES sites (site_id)
  ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE keywords (
  keyword_id int(11) NOT NULL AUTO_INCREMENT,
  keyword varchar(35) NOT NULL,
  PRIMARY KEY (keyword_id),
  UNIQUE KEY kw (keyword),
  KEY keyword (keyword(10))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword0 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword0_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword0_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword1 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword1_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword1_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword2 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword2_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword2_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword3 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword3_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword3_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword4 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword4_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword4_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword5 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword5_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword5_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword6 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword6_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword6_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword7 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword7_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword7_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword8 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword8_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword8_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyword9 (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyword9_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyword9_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyworda (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyworda_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyworda_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keywordb (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keywordb_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keywordb_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keywordc (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keywordc_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keywordc_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keywordd (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keywordd_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keywordd_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keyworde (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keyworde_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id
  ) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keyworde_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE link_keywordf (
  link_id int(11) NOT NULL,
  keyword_id int(11) NOT NULL,
  weight int(3) DEFAULT NULL,
  domain int(4) DEFAULT NULL,
  KEY linkid (link_id),
  KEY keyid (keyword_id),
  CONSTRAINT link_keywordf_ibfk_1 FOREIGN KEY (link_id) REFERENCES links (link_id)
  ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT link_keywordf_ibfk_2 FOREIGN KEY (keyword_id)
  REFERENCES keywords (keyword_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE categories (
  category_id int(11) NOT NULL AUTO_INCREMENT,
  category text,
  parent_num int(11) DEFAULT NULL,
  PRIMARY KEY (category_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE site_category (
  site_id int(11) DEFAULT NULL,
  category_id int(11) DEFAULT NULL,
  KEY site_category_ibfk_1 (site_id),
  CONSTRAINT site_category_ibfk_1 FOREIGN KEY (site_id) REFERENCES sites (site_id)
  ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE temp (
  link varchar(255) DEFAULT NULL,
  level int(11) DEFAULT NULL,
  id varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE pending (
  site_id int(11) DEFAULT NULL,
  temp_id varchar(32) DEFAULT NULL,
  level int(11) DEFAULT NULL,
  count int(11) DEFAULT NULL,
  num int(11) DEFAULT NULL,
  KEY site_id (site_id),
  CONSTRAINT pending_ibfk_1 FOREIGN KEY (site_id) REFERENCES sites (site_id)
  ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE query_log (
  query varchar(255) DEFAULT NULL,
  time timestamp NULL DEFAULT NULL,
  elapsed float DEFAULT NULL,
  results int(11) DEFAULT NULL,
  KEY query_key (query)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE domains (
  domain_id int(11) NOT NULL AUTO_INCREMENT,
  domain varchar(255) DEFAULT NULL,
  PRIMARY KEY (domain_id)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
CREATE TABLE settings (
  id int(11) NOT NULL AUTO_INCREMENT,
  version_nr varchar(10) DEFAULT NULL,
  slanguage varchar(5) DEFAULT NULL,
  template varchar(15) DEFAULT NULL,
  admin_email varchar(45) DEFAULT NULL,
  print_results int(11) DEFAULT NULL,
  tmp_dir varchar(25) DEFAULT NULL,
  windows_os int(11) DEFAULT NULL,
  keep_log int(11) DEFAULT NULL,
  log_dir varchar(25) DEFAULT NULL,
  log_format varchar(15) DEFAULT NULL,
  email_log int(11) DEFAULT NULL,
  min_words_per_page int(11) DEFAULT NULL,
  min_word_length int(11) DEFAULT NULL,
  word_upper_bound int(11) DEFAULT NULL,
  index_numbers int(11) DEFAULT NULL,
  index_decimals int(11) DEFAULT NULL,
  dec_separator varchar(2) DEFAULT NULL,
  index_host int(11) DEFAULT NULL,
  index_meta_keywords int(11) DEFAULT NULL,
  index_pdf int(11) DEFAULT NULL,
  index_doc int(11) DEFAULT NULL,
  index_xls int(11) DEFAULT NULL,
  index_ppt int(11) DEFAULT NULL,
  pdftotext_path varchar(45) DEFAULT NULL,
  catdoc_path varchar(45) DEFAULT NULL,
  xls2csv_path varchar(45) DEFAULT NULL,
  catppt_path varchar(45) DEFAULT NULL,
  pandoc_path varchar(45) DEFAULT NULL,
  user_agent varchar(50) DEFAULT NULL,
  min_delay int(11) DEFAULT NULL,
  pause_ int(11) DEFAULT NULL,
  pause_time int(11) DEFAULT NULL,
  pause_pages int(11) DEFAULT NULL,
  stem_words int(11) DEFAULT NULL,
  stem_language varchar(20) DEFAULT NULL,
  strip_sessids int(11) DEFAULT NULL,
  results_per_page int(11) DEFAULT NULL,
  cat_columns int(11) DEFAULT NULL,
  bound_search_result int(11) DEFAULT NULL,
  length_of_link_desc int(11) DEFAULT NULL,
  links_to_next int(11) DEFAULT NULL,
  qfloor int(11) DEFAULT NULL,
  show_meta_description int(11) DEFAULT NULL,
  advanced_search int(11) DEFAULT NULL,
  show_result_number int(11) DEFAULT NULL,
  show_index_date int(11) DEFAULT NULL,
  show_url int(11) DEFAULT NULL,
  show_query_scores int(11) DEFAULT NULL,
  show_stars int(11) DEFAULT NULL,
  show_categories int(11) DEFAULT NULL,
  desc_length int(11) DEFAULT NULL,
  merge_site_results int(11) DEFAULT NULL,
  did_you_mean_enabled int(11) DEFAULT NULL,
  suggest_enabled int(11) DEFAULT NULL,
  suggest_history int(11) DEFAULT NULL,
  suggest_keywords int(11) DEFAULT NULL,
  weighted_keywords int(11) DEFAULT NULL,
  suggest_phrases int(11) DEFAULT NULL,
  suggest_rows int(11) DEFAULT NULL,
  title_weight int(11) DEFAULT NULL,
  domain_weight int(11) DEFAULT NULL,
  path_weight int(11) DEFAULT NULL,
  meta_weight int(11) DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
INSERT INTO settings VALUES (
    1,
    '2.6.1',
    'en',
    'standard',
    'admin@admin.com',
    1,
    'tmp',
    0,
    1,
    'log',
    'html',
    0,
    10,
    5,
    100,
    1,
    0,
    '.',
    0,
    1,
    0,
    0,
    0,
    0,
    '/usr/bin/pdftotext',
    '/usr/bin/catdoc',
    '/usr/bin/xls2csv',
    '/usr/bin/catppt',
    '/usr/bin/pandoc',
    'Sphider (sphidersearch.com)',
    0,
    0,
    120,
    30,
    0,
    'English',
    1,
    10,
    2,
    0,
    0,
    9,
    0,
    1,
    0,
    1,
    0,
    1,
    1,
    0,
    1,
    250,
    0,
    1,
    1,
    1,
    0,
    0,
    0,
    10,
    20,
    60,
    10,
    5);
    
